#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include "hofmeier.h"


/* function zum Herunterfahren ! */
static void finish(int sig);

int hsize = 0;
int hakt  = 0;
int hdis  = 0;
int vsize = 0;
int vakt  = 1;
int vdis  = 1;
char *psi[10000];


paint()
{
  int i;
  char cd[256];

  makeline(LOECK, HLINE, ROECK, 1, 1);
  makeline(VLINE, NOMBG, VLINE, 1, 2);
  gotoxy(3, 2);
  addstr("Blacky's Procesc Control (c) Copyright by Andreas Hofmeier Computer Programme");
  makeline(RABGE, HLINE, LABGE, 1, 3);
  makeline(VLINE, NOMBG, VLINE, 1, 4);
  /*  gotoxy(3, 4);
  addstr("UP DN-Scrol; SPACE-Select; ENTER-EXIT & Rckgabe; C-c-EXIT");*/
  makeline(VLINE, NOMBG, VLINE, 1, 5);
  makeline(RABGE, HLINE, LABGE, 1, 6);
  makeline(VLINE, NOMBG, VLINE, 1, 7);
  makeline(VLINE, NOMBG, VLINE, 1, 8);
  makeline(VLINE, NOMBG, VLINE, 1, 9);
  makeline(VLINE, NOMBG, VLINE, 1, 10);
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(VLINE, NOMBG, VLINE, 1, 19);
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(VLINE, NOMBG, VLINE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);
  makeline(LUECK, HLINE, RUECK, 1, 24);

  /*  gotoxy(65, 19);
  sprintf(mull, "?%d/%d", akt, ges);
  addstr(mull);*/

  /* Auerhalb des Fenster? */
  if (vakt > vsize)
    {
      vakt = vsize;
    }
  if (vdis > vsize - 15)
    {
      vdis = vsize - 15;
    }
  if ((vakt < 1) || (vdis < 1))
    {
      vakt = 1;
      vdis = 1;
    }
  if (vakt < vdis)
    {
      vdis = vakt;
    }
  if (vakt > (vdis + 16))
    {
      vdis = (vakt - 16);
    }
  /*  if ((vakt - vdis) > 15)
    {
      vakt--;
      }*/
  /* Headline */
  gotoxy(3, 7);
  addstr(psi[0]);
  /* Aufbau */
  for (i = 0; i < 16; i++)
    {
      if ((psi[vdis + i] != NULL) && ((vdis + i) <= vsize))
	{
	  gotoxy(3, 8 + i);
	  strcpy(cd, psi[vdis + i]);
	  cd[76] = 0;
	  addstr(cd);
	}
    }
  /* Cursor */
  i = 8 + (vakt - vdis);
  gotoxy(1, i);
  addstr("->");
  gotoxy(79, i);
  addstr("<-");
  gotoxy(3, i);
  refresh(); 
}


getpsinfo()
{
  FILE *f;
  int i;
  int i2;
  char cd[500];

  system("ps auxwww > /tmp/.Blacky_PS_info_ps-file.ahcp");
  f = fopen("/tmp/.Blacky_PS_info_ps-file.ahcp", "r");
  if (f == NULL)
    {
      endwin();
      perror("/tmp/.Blacky_PS_info_ps-file.ahcp");
      exit(1);
    }
  for (i = 0; (feof(f) == 0) ; i++)
    {
      dosread(f, cd);
      if (cd[0] != 0)
	{
	  i2 = strlen(cd);
	  /* Lngster eintrag */
	  if (i2 > hsize)
	    {
	      hsize = i2;
	    }
	  psi[i] = (char *) malloc(i2 + 1);
	  if (psi[i] == NULL)
	    {
	      endwin();
	      perror("");
	      exit(1);
	    }
	  strcpy(psi[i], cd);
	}
    }

  /* Anzahl der Zeilen, ohne Oberste */
  vsize = (i - 1);

  /*int hsize = 0;
    int hakt  = 0;
    int vsize = 0;
    int vakt  = 0;  */

  fclose(f);
}


main(argc, argv)
  int argc;
  char *argv[];
{
  int i;

  getpsinfo();

  /*printf("ts %d\n", vsize);
    exit(0);*/

  /*for (i = 0; psi[i] != NULL; i++)
    {
    printf("%d --> %s\n", i, psi[i]);
    }
    exit(0);*/
  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  /* Init curses ... */
  /* setupterm(); */           /* Init a goot Terminal */
  (void) initscr();              /* initialize the curses library */
  /*keypad(stdscr, FALSE);... nur Scheie! */
  keypad(stdscr, TRUE);
  (void) nonl();                 /* tell curses not to do NL->CR/NL on output */
  (void) cbreak();               /* take input chars one at a time, no wait for \n */
  (void) noecho();               /* don't echo input */
  /* Init curses colores ... */
  if (has_colors())
    {
      start_color();
      /*
       * Simple color assignment, often all we need.
       */
      init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
      init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
      init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
      init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
      init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
      init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
      init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
      init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
    }
  /* Hauptschleife */
  paint();
  do
     {
       /*       gotoxy(14, 23);    */
       paint();
       switch (getch())
         {
	   /* EXIT */
	 case 'X':
	 case 'x':
	 case 'Q':
	 case 'q':
	   finish(0);
	   break;

	   /* DN */
	 case 258:
	 case '-':
	   vakt++;
	   if (vakt > vsize)
	     {
	       vakt = vsize;
	     }
	   break;

	   /* UP */
	 case 259:
	 case '+':
	   if (vakt > 1)
	     {
	       vakt--;
	     }
	   break;

	   /* <- */
	 case 260:
	 case '<':
	   if (hakt > 0)
	     {
	       hakt--;
	     }
	   break;

	   /* -> */
	 case 261:
	 case '>':
	   hakt++;
	   if (hakt > hsize)
	     {
	       hakt = hsize;
	     }
	   break;

	   /* PG-UP */
	 case 339:
	   if (vakt > 16)
	     {
	       vakt -= 16;
	       vdis -= 16;
	     }
	   else
	     {
	       vakt = 1;
	       vdis = 1;
	     }
	   break;

	   /* PG-DN */
	 case 338:
	   if (vakt < (vsize - 17))
	     {
	       vakt += 16;
	       vdis += 16;
	     }
	   else
	     {
	       vakt = vsize;
	       vdis = vsize - 16;
	     }
	   break;

	   /* Wenn keine bekannte Taste gedrckt wurde */
	 default:
	   /*endwin();*/
	   paint();
	   break;

         } /* END CASE */     
   } while (1);

  /*
   GoToXY(50, 5);
   X := von Rechtz
   Y := von Links
  */

  /* move(o, l) :
      Bei NULL beginnend !!!
      o = von oben;
      l = von links; */
}


static void finish(int sig)
{
  /* Herrunterfahren */
  endwin();
  exit(0);
}
