/*
    bps (Blacky's Process Status)

    Dieses Programm ist eine graphische Oberflche fr ps, renice
    und kill fr die Console.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <unistd.h>
//#include "hofmeier.h"
#include <time.h>

#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#include <fcntl.h>

/* Graphikzeichensatz des Terminals Aktiviren... */
#define BLACKY_cur_Graphik 1

#define MAXLI 80  /* Maximale Lnge Ver.*/
char HLINE, VLINE, ROECK, RABGE, RUECK, LOECK, LABGE, LUECK, NOMBG, OABGE, UABGE, KREUZ;



char blacky_ver_info[] = "Blacky's Process Status v0.90 (c) Copyright 1998-2003,2007 Andreas Hofmeier";


/* function zum Herunterfahren ! */
static void finish(int sig);
/* UHR function */
/*static void uhr(int sig);*/
/* Autoreload */
static void reload(int sig);
unsigned int reloadtime = 0;

/* Fenstergroe gendert? */
static void fg(int sig);
/*static void alarmf(int sig);*/

/* PS-Tree */
char pstree = 0;
/* Maximale Lnge */
int hsize = 0;
/* Maximale Lnge zum Scrolen */
int phsize = 0;
/* Aktuelle Position Horizontal, ganz vorne */
int hdis  = 0;
/* Anzahl der Eintrge */
int vsize = 0;
/* Anzahl der Eintrge zum Scrolen */
int pvsize = 0;
/* Aktuelle Position Vertikal*/
int vakt  = 0;
/* Aktuelle Position Vertikal, ganz vorne */
int vdis  = 0;
/* Autoscan */
int u = 0;
/* Gre des xTerminals */
int zeilen = 25;
int zeichen = 80;
unsigned long u2 = 0;
#define PSISIZE 50000
/* Alle Processe */
char *psi [PSISIZE];
/* Lngen der Zeilen */
int   psil[PSISIZE];
/* titel */
char *titel;
/* Lnge titel */
int   titell;
char *suchstr;
char *psparam = NULL;
/* Process info modus */
char processinfo = 0;
/* Wenn reload und Processinfo */
int reload_getprocessinfo_pid = 0;
// Ganzer Bildschirm!
int vollbild = 0;
int lineoffset;

int BUFSIZE = 512;

char *EDITOR;


b_addstr(char *str, int maxl)
{
  char ustr[300];

  strncpy(ustr, str, maxl - 4);
  ustr[maxl - 4] = 0;
  addstr(ustr);
}


paint()
{
  int i, i2;
  char cd[256];
  char markline = 0;

  // kein Cursor
  curs_set(0);

  if ((zeilen - 8) > vsize) {
    pvsize = (zeilen - 9);
  } else {
    if (pvsize != vsize) {
      pvsize = vsize;
    }
  }
  if ((zeichen - 4) > hsize) {
    phsize = (zeichen - 5);
  } else {
    if (phsize != hsize) {
      phsize = hsize;
    }
  }

  // Ganzer Bildschirm
  if (vollbild) {
    lineoffset = 1;
    for (i = 1; i <= zeilen; i++) {
      if (i == 1) {
	makeline2(LOECK, HLINE, ROECK, 1, 1, zeichen);
      } else {
	if (i != zeilen) {
	  makeline2(VLINE, NOMBG, VLINE, 1, i, zeichen);
	} else {
	  makeline2(LUECK, HLINE, RUECK, 1, zeilen, zeichen);
	}
      }
    }
    // Normale Ansicht
  } else {
    lineoffset = 6;
    for (i = 1; i <= zeilen; i++) {
      switch (i) {
      case 1:
	makeline2(LOECK, HLINE, ROECK, 1, 1, zeichen);
	break;
      case 2:
	makeline2(VLINE, NOMBG, VLINE, 1, 2, zeichen);
	gotoxy(3, 2);
	/*  addstr("Blacky's Process Status (c) Copyright by Andreas Hofmeier Computer Programme");*/
	b_addstr(blacky_ver_info, zeichen);
	break;
      case 3:
	makeline2(RABGE, HLINE, LABGE, 1, 3, zeichen);
	break;
      case 4:
	makeline2(VLINE, NOMBG, VLINE, 1, 4, zeichen);
	gotoxy(3, 4);
	if (!processinfo) {
	  b_addstr("UP DN=Select x=EXIT N=reNICE /,n=Search I=P-Info i=L-Info r=reScan t=Tree"/* U=AutoScan"*/, zeichen);
	} else {
	  b_addstr("UP DN=Select x=EXIT /,n=Search r=reScan", zeichen);
	}
	/*  addstr((pstree == 0) ? "Tree" : "Liste");*/
	break;
      case 5:
	makeline2(VLINE, NOMBG, VLINE, 1, 5, zeichen);
	gotoxy(3, 5);
	if (!processinfo) {
	  b_addstr("A=hangup(1) B=quit(3) C=terminate(15) D=stop(19) E=continue(18) F=KILL(9)", zeichen);
	}
	break;
      case 6:
	makeline2(RABGE, HLINE, LABGE, 1, 6, zeichen);
	break;
      default:
	if (i != zeilen) {
	  makeline2(VLINE, NOMBG, VLINE, 1, i, zeichen);
	  break;
	} else {
	  makeline2(LUECK, HLINE, RUECK, 1, zeilen, zeichen);
	  break;
	}
      } /*switch*/
    }
  }

  /* Auerhalb des Schirms? */
  if (vakt < vdis) {
    vdis = vakt;
  }
  if (vakt > (vdis + (zeilen - lineoffset - 3 /*9*/) /*15*/)) {
    vdis = (vakt - (zeilen - lineoffset - 3 /*9*/) /*15*/);
  }
  /* Auerhalb der Gltzigen Werte? */
  if ((vakt < 0) || (vdis < 0)) {
    vakt = 0;
    vdis = 0;
  }
  if ((vakt > pvsize) || (vdis > (pvsize - (zeilen - lineoffset - 3 /*9*/) /*15*/))) {
    vakt = pvsize;
    vdis = pvsize - (zeilen - lineoffset - 3 /*9*/) /*15*/;
  }
  if (hdis < 0) {
    hdis = 0;
  }
  if ((hdis > (phsize - (zeichen - 5) /*75*/))) {
    hdis = phsize - (zeichen - 5)/*75*/;
  }
  /* Kopfzeile */
  gotoxy(3, lineoffset + 1 /*7*/);
  if (hdis < titell) {
    b_addstr(titel + hdis, zeichen);
  }
  /* Aufbau 16 Zeilen */
  for (i = 0; i < (zeilen - lineoffset - 2 /*8*/)/*16*/; i++) {
    gotoxy(3, i + lineoffset + 2 /*8*/);
    /* Wenn die Aktuelle zeile die Ausgewhlte ist, markieren ... */
    if (i == (vakt - vdis)) {
      markline = 1;
      attrset(A_REVERSE /* A_STANDOUT */);
    } else {
      markline = 0;
    }
    if (hdis < psil[vdis + i]) {
      if ((psi[vdis + i]) != NULL) {
	strncpy(cd, psi[vdis + i] + hdis, 200);
      } else {
	cd[0] = 0;
      }
      cd[zeichen - 4 /*76*/] = 0;
    } else {
      cd[0] = 0;
    }
#ifdef BLACKY_cur_Graphik
    if (HLINE != '-') {
      int i;
      char xstr_a[3] = { RABGE, HLINE, 0};
      char xstr_b[2] = { VLINE, 0};
      char xstr_c[3] = { LUECK, HLINE, 0};
	  
      for (i = 0; cd[i] != 0; i++) {
	switch (cd[i]) {
	case '|':
	  if (cd[i + 1] == '-') {
	    attrset(A_ALTCHARSET);
	    if (markline == 1) {
	      attron(A_REVERSE /* A_STANDOUT */);
	    }
	    //		      addch(RABGE);
	    //		      addch(HLINE);
	    addstr(xstr_a/*"tq"*/); /* |- */
	    attrset((markline == 1) ? A_REVERSE /* A_STANDOUT */ : A_NORMAL);
	    i++;
	  } else {
	    attrset(A_ALTCHARSET);
	    if (markline == 1) {
	      attron(A_REVERSE /* A_STANDOUT */);
	    }
	    //		      addch(VLINE);
	    addstr(xstr_b/*"x"*/); /* | */
	    attrset((markline == 1) ? A_REVERSE /* A_STANDOUT */ : A_NORMAL);
	  }
	  break;
	case '`':
	  attrset(A_ALTCHARSET);
	  if (markline == 1) {
	    attron(A_REVERSE /* A_STANDOUT */);
	  }
	  //		  addch(LUECK);
	  //		  addch(HLINE);
	  addstr(xstr_c/*"mq"*/); /* |_ */
	  attrset((markline == 1) ? A_REVERSE /* A_STANDOUT */ : A_NORMAL);
	  i++;
	  break;
	default:
	  addch(cd[i]);
	  break;
	} /*switch*/
      }
    } else
#endif
      {
	addstr(cd);
      }
    /* Hervorhebung aufheben, wenn verhanden */
    if (markline == 1) {
      attrset(A_NORMAL);
    }
  }
  /* Wo ? */
  gotoxy((zeichen / 2) - 3/*36*/, lineoffset /*6*/);
  sprintf(cd, "<%d/%d>", vakt + 1, vsize + 1);
  addstr(cd);
  /* Scrollbar */
  i = (int) ((double) (zeilen - lineoffset - 2 /*8*/)/*16*/ * ((double) (vakt) / (double) (vsize + 1)));
  gotoxy(1, i + lineoffset + 2/*8*/);
  addstr("#");

  /* Horizontal */
  i2 = (int) ((double) (
	      (double) hdis / (double) (hsize - (zeichen - 5)) * (double) (zeichen - 3)));
  gotoxy(i2 + 2, zeilen /*24*/);
  addstr("#");

  /* Vertikal */
  i = (vakt - vdis) + lineoffset + 2 /*8*/;
  gotoxy(2, i);
  addstr(">");
  gotoxy(/*79*/zeichen - 1, i);
  addstr("<-");
  /* Cursor */
  gotoxy(i2, i);

  /* UHR */
  /*  uhr(128);*/

  /*  refresh();*/
  if (u != 0) {
    char s[10];

    gotoxy(3, 6);
    sprintf(s, "U=%d", u);
    addstr(s);
  }
}


getpsinfo()
{
  FILE *f;
  int i;
  char cd[BUFSIZE];

  // Scrol-Lnge Reset
  hsize = 0;

  /* Lschen des Buffers */
  for (i = 0; i < PSISIZE; i++) {
    if (psi[i] != NULL)	{
      free(psi[i]);
      psi[i] = NULL;
    }
  }
  /* Titel Freigeben */
  free(titel);
  /* Runnig PS */
  if (pstree == 0) {
    if (psparam == NULL) {
      if ((f = popen("ps auxww", "r")) == NULL) {
	return;
      }
    } else {
      static char comm[100];

      sprintf(comm, "ps %s", psparam);
      if ((f = popen(comm, "r")) == NULL) {
	return;
      }
    }
  } else {
    //    if ((f = popen("pstree -alpu", "r")) == NULL) {
    if ((f = popen("pstree -Aalpu", "r")) == NULL) {
      return;
    }
  }
  /* Titel */
  if (pstree == 0) {
    dosread(f, cd, BUFSIZE - 1);
  } else {
    strcpy(cd, "PS-Tree");
  }
  titell = strlen(cd);
  titel = (char *) malloc(titell + 1);
  if (titel == NULL) {
    endwin();
    perror("");
    exit(1);
  }
  strcpy(titel, cd);
  /* Lesen des Records */
  for (i = 0; (feof(f) == 0) ; i++) {
    dosread(f, cd, BUFSIZE - 1);
    if (cd[0] != 0) {
      getprocessinfo_addline(cd, i);
    }
  }
  /* Anzahl der Zeilen, ohne Oberste */
  vsize = (i - 2);
  /* Close */
  pclose(f);
  /* Temporre Dateien Lschen */
  remove("/tmp/.Blacky_PS_info_ps-file.ahcp");
}

getprocessinfo_addline(cd, i)
  char *cd;
  int i;
{
  psil[i] = strlen(cd);
  /* Lngster eintrag */
  if (psil[i] > hsize) {
    hsize = psil[i];
  }
  psi[i] = (char *) malloc(psil[i] + 1);
  if (psi[i] == NULL) {
    endwin();
    perror("");
    exit(1);
  }
  strcpy(psi[i], cd);
}

getprocessinfo(int pid)
{
  int i;
  char cd[BUFSIZE];

  // Scrol-Lnge Reset.
  hsize = 0;

  /* Lschen des Buffers */
  for (i = 0; i < PSISIZE; i++) {
    if (psi[i] != NULL) {
      free(psi[i]);
      psi[i] = NULL;
    }
  }
  /* Parameter */
  i = 0;
  {
    struct dirent *dir;
    DIR *d;
    struct stat filestat;
    int fdnum;
    char perm[3];
    char cd[BUFSIZE];
    char procdir[100];
    int plen = 0;
    char buf[80];

    int len, i2;
    int fd;
    char pp;

    sprintf(procdir, "/proc/%d/", pid);
    plen = strlen(procdir);

    // Commandozeile
    strcpy(cd, "  ");
    strcpy(procdir + plen, "cmdline");
    if ((fd = open(procdir, O_RDONLY)) < 0) {
      getprocessinfo_addline("** ERROR: No such process or /proc not mounted!", 0);
    } else {
      len = read(fd, cd + 2, BUFSIZE - 2);
      for (i2 = 0; i2 < len; i2++) {
	if (cd[i2 + 2] == 0) {
	  cd[i2 + 2] = ' ';
	}
      }
      if (len != 0) {
	cd[len + 2] = 0;
	getprocessinfo_addline("Commandline", i++);
	getprocessinfo_addline(cd, i++);
      }
      close(fd);
      
      // Allgemeine Infos
      {
	FILE *f;
	strcpy(procdir + plen, "status");
	
	f = fopen(procdir, "r");
	if (f != NULL) {
	  getprocessinfo_addline("Allgemeines", i++);
	  strcpy(cd, "  ");
	  while (feof(f) == 0) {
	    dosread(f, cd + 2, BUFSIZE - 2);
	    if (cd[2] != 0) {
	      getprocessinfo_addline(cd, i++);
	    }
	  }
	  fclose(f);
	}
	
	//      FILE *f;
	strcpy(procdir + plen, "stat");
	
	if ((f = fopen(procdir, "r")) != NULL) {
	  char state;
	  unsigned long ppid, pgrp, session, tty, tpgid, priority, vsize, rss;
	  
	  //	getprocessinfo_addline("Allgemeines", i++);
	  fscanf(f, "%*d %*s %c %d %d %d %d %d %*u %*u %*u %*u %*u %*d %*d %*d %*d %*d %d %*u %*u %*d %u %u %*u %*u %*u %*u %*u %*u %*d %*d %*d %*d %*u",
		 &state, &ppid, &pgrp, &session, &tty, &tpgid, &priority, &vsize, &rss);
	  fclose(f);
	  
	  /*	strcpy(cd, "  ");
		sprintf(cd + 2, "Status: %c (", state);
		switch(state) {
		case 'R':
		strcat(cd, "running (aktiv))");
		break;
		case 'S':
		strcat(cd, "sleeping (inaktiv))");
		break;
		case 'D':
		strcat(cd, "nicht aktivierbar oder ausgelagert)");
		break;
		case 'Z':
		strcat(cd, "zombie (Prozeleiche))");
		break;
		case 'T':
		strcat(cd, "traced/stopped (reagiert auf ein Signal))");
		break;
		}
		getprocessinfo_addline(cd, i++);
		
		sprintf(cd + 2, "Elternprozesses-ID: %d", ppid);
		getprocessinfo_addline(cd, i++);
		
		sprintf(cd + 2, "Gruppen-ID: %d", pgrp);
		getprocessinfo_addline(cd, i++);
		
		sprintf(cd + 2, "Sitzungs-ID: %d", session);
		getprocessinfo_addline(cd, i++);
		
		sprintf(cd + 2, "TTY: %d", tty);
		getprocessinfo_addline(cd, i++);
		
		sprintf(cd + 2, "Prozegruppen-ID: %d", tpgid);
		getprocessinfo_addline(cd, i++);
	  */
	  sprintf(cd + 2, "Priority: %d", priority);
	  getprocessinfo_addline(cd, i++);
	  /*
	    sprintf(cd + 2, "virtuellen Speicher: %d", vsize);
	    getprocessinfo_addline(cd, i++);
	    
	    sprintf(cd + 2, "Resident Set Size: %d", rss - 3);
	    getprocessinfo_addline(cd, i++);
	  */
	}
      }
      
      // PWD
      strcpy(procdir + plen, "cwd");
      if ((len = readlink(procdir, buf, sizeof(buf) - 1)) > 0) {
	buf[len] = 0;
	sprintf(cd, "PWD:  %s", buf);
	getprocessinfo_addline(cd, i++);
      }
      // EXE
      strcpy(procdir + plen, "exe");
      if ((len = readlink(procdir, buf, sizeof(buf) - 1)) > 0) {
	buf[len] = 0;
	sprintf(cd, "EXE:  %s", buf);
	getprocessinfo_addline(cd, i++);
      }
      // ROOT
      strcpy(procdir + plen, "root");
      if ((len = readlink(procdir, buf, sizeof(buf) - 1)) > 0) {
	buf[len] = 0;
	sprintf(cd, "ROOT: %s", buf);
	getprocessinfo_addline(cd, i++);
      }
      
      // Lesen der FDs
      strcpy(procdir + plen, "fd/");
      if ((d = opendir(procdir)) != NULL) {
	getprocessinfo_addline("Open Files", i++);
	while((dir = readdir(d)) != 0) {
	  if(dir->d_name[0] == '.')
	    continue;           // skip . and ..
	  fdnum = atoi(dir->d_name);
	  strcpy(procdir + plen + 3, dir->d_name);
	  strcpy(perm, "--");
	  if(lstat(procdir, &filestat) >= 0){
	    if(filestat.st_mode & 0400) perm[0] = 'r';
	    if(filestat.st_mode & 0200) perm[1] = 'w';
	  }
	  
	  if( (len = readlink(procdir, buf, sizeof(buf) - 1)) > 0) {
	    unsigned long dev, ino;
	    buf[len] = '\0';
	    if((buf[0] == '['       // Linux 2.0 style /proc/fd
		&& sscanf(buf, "[%lx]:%lu", &dev, &ino) == 2
		&& dev == 0)
	       || sscanf(buf, "socket:[%lu]", &ino) > 0) { // Linux 2.1
	      /* Suche INODE des Sockets in /proc/net/tcp */
	      FILE *f;
	      unsigned long localaddr, localport, remoteaddr, remoteport, sock;
	      char cd[BUFSIZE];

	      f = fopen("/proc/net/tcp", "r");
	      if (f != NULL) {
		fgets(cd, BUFSIZE, f);
		while (!feof(f)) {
		  fgets(cd, BUFSIZE, f);
		  sscanf(cd, "%*d: %x:%x %x:%x %*x %*x:%*x %*x:%*x %*x %*d %*d %d\n", &localaddr, &localport, &remoteaddr, &remoteport, &sock);
		  if (sock == ino) {
		    // Ich wei nicht warum, aber sprintf macht einen Fehler! ?? :-( ??
		    //		  sprintf(cd, "  %03d %2s TCP-Socket:         %05d (local:%15s:%05d remote: %15s:%05d)", fdnum, perm, sock, ((localaddr == 0) ? "*" : inet_ntoa(localaddr)), localport, ((remoteaddr == 0) ? "*" : inet_ntoa(remoteaddr)), remoteport);
		    sprintf(cd, "  %03d %2s TCP-Socket:         %05d (local:%15s:%05d remote: ", fdnum, perm, sock, ((localaddr == 0) ? "*" : (char *) inet_ntoa(localaddr)), localport);
		    sprintf(cd + strlen(cd), "%15s:%05d)", ((remoteaddr == 0) ? "*" : (char *) inet_ntoa(remoteaddr)), remoteport);
		    getprocessinfo_addline(cd, i++);
		    fclose(f);
		    goto SOCKSCANOK;
		  }
		}
		fclose(f);
	      }
	      /* Suche INODE des Sockets in /proc/net/udp */
	      f = fopen("/proc/net/udp", "r");
	      if (f != NULL) {
		fgets(cd, BUFSIZE, f);
		while (!feof(f)) {
		  fgets(cd, BUFSIZE, f);
		  sscanf(cd, "%*d: %x:%x %x:%x %*x %*x:%*x %*x:%*x %*x %*d %*d %d\n", &localaddr, &localport, &remoteaddr, &remoteport, &sock);
		  if (sock == ino) {
		    sprintf(cd, "  %03d %2s UDP-Socket:         %05d (local:%15s:%05d remote: %15s:%05d)", fdnum, perm, sock, (localaddr == 0) ? "*" : (char *) inet_ntoa(localaddr), localport, (remoteaddr == 0) ? "*" : (char *) inet_ntoa(remoteaddr), remoteport);
		    getprocessinfo_addline(cd, i++);
		    fclose(f);
		    goto SOCKSCANOK;
		  }
		}
		fclose(f);
	      }
	      /* Suche INODE des Sockets in /proc/net/unix */
	      f = fopen("/proc/net/unix", "r");
	      if (f != NULL) {
		fgets(cd, BUFSIZE, f);
		while (!feof(f)) {
		  char cd2[BUFSIZE];
		  fgets(cd, BUFSIZE, f);
		  sscanf(cd, "%*x: %*x %*x %*x %*x %*x %d %s\n", &sock, cd2);
		  if (sock == ino) {
		    sprintf(cd, "  %03d %2s UNIX-Domain-Socket: %05d (%s)", fdnum, perm, sock, cd2);
		    getprocessinfo_addline(cd, i++);
		    fclose(f);
		    goto SOCKSCANOK;
		  }
		}
		fclose(f);
	      }
	      
	       SOCKSCANOK: ;
	      
	    } else {
	      sprintf(cd, "  %03d %2s %s", fdnum, perm, buf);
	      getprocessinfo_addline(cd, i++);
	    }
	  }
	  
	}
	closedir(d);
      }

      // MEM-Maps
      {
	FILE *f;
	pp = 0;
	strcpy(procdir + plen, "maps");
	if ((f = fopen(procdir, "r")) != NULL) {
	  strcpy(cd, "  ");
	  while (feof(f) == 0) {
	    dosread(f, cd + 2, BUFSIZE + 2);
	    if (cd[2] != 0) {
	      if (pp == 0) {
		getprocessinfo_addline("Memorymaps", i++);
		pp = 1;
	      }
	      getprocessinfo_addline(cd, i++);
	    }
	  }
	  fclose(f);
	}
      }
      
      // Environment
      {
	FILE *f;
	pp = 0;
	strcpy(procdir + plen, "environ"); 
	f = fopen(procdir, "r");
	if (f != NULL) {
	  strcpy(cd, "  ");
	  while (feof(f) == 0) {
	    int il;
	    while (feof(f) == 0) {
	      for (il = 2; (cd[il - 1] != 0) && (feof(f) == 0); il++) {
		fread(cd + il, 1, 1, f);
	      }
	      cd[il - 1] = 0;
	      if (cd[2] != 0) {
		if (pp == 0) {
		  getprocessinfo_addline("Environment", i++);
		  pp = 1;
		}
		getprocessinfo_addline(cd, i++);
	      }
	    }
	  }
	  fclose(f);
	}
      }
    }
  }
  // ??
  vsize = (i == 0) ? 1 : (i - 1);
}


srcprocessinfo()
{
  int xvakt, xhdis;
  int pid;

  xvakt = vakt;
  xhdis = hdis;
  pid = getpnummer(vakt);
  reload_getprocessinfo_pid = pid;
  hdis = vakt = 0;

  processinfo = 1;
  {
    char cd[80];
    /* Titel Freigeben */
    free(titel);
    /* Titel */
    sprintf(cd, "Processinfo: %d", pid);
    titell = strlen(cd);
    titel = (char *) malloc(titell + 1);
    strcpy(titel, cd);
  }
  getprocessinfo(pid);

  do {
    /*       gotoxy(14, 23);    */
    paint();
    switch (getch())
      {
	/* EXIT */
      case 'X':
      case 'x':
      case 'Q':
      case 'q':
      case '<':
	//	case 260:
	processinfo = 0;
	vakt = xvakt;
	getpsinfo();
	paint();
	return 0;
	//	  finish(0);
	break;
	
	/* DN */
      case 258:
      case '-':
	vakt++;
	break;
	
	/* UP */
      case 259:
      case '+':
	vakt--;
	break;
	
	/* <- */
      case 260:
	//	case '<':
	hdis -= 5;
	break;
	
	/* -> */
      case 261:
      case '>':
	hdis += 5;
	break;
	
	/* PG-UP */
      case 339:
	vakt -= (zeilen - 8) /* 16 */;
	vdis -= (zeilen - 8) /* 16 */;
	break;
	
	/* PG-DN */
      case 338:
	vakt += (zeilen - 8) /* 16 */;
	vdis += (zeilen - 8) /* 16 */;
	break;
	
	/* ReScan */
      case 'r':
      case 'R':
	getprocessinfo(pid);
	break;
	
	/* Suchen */
      case '/':
      case 's':
      case 'S':
	{
	  char s[200];
	  
	  /*	     nouhr = 1;*/
	  endwin();
	  fprintf(stderr, "Search for: ");
	  scanf("%s", s);
	  suchstr = (char *) malloc(strlen(s) + 1);
	  if (suchstr == NULL) {
	    perror("");
	    exit(1);
	  }
	  /*	     strcpy(suchstr, s);*/
	  Gross(suchstr, s);
	  /*	     nouhr = 0;*/
	  suchen(0);
	}
	break;
	
	/* to HOME */
      case 262:
	vakt = 0;
	hdis = 0;
	break;
	
	/* to END */
      case 360:
	vakt = vsize;
	hdis = 0;
	break;
	
	/* W-Suchen */
      case 'n':
	if (suchstr == NULL) {
	  break;
	}
	suchen(vakt + 1);
	break;
	
	// Redraw  - C-l
      case ' ':
      case 12:
	endwin();
	paint();
	break;
	  
	/* Wenn keine bekannte Taste gedrckt wurde */
      default:
	break;
      } /* END CASE */     
  } while (1);
  
  processinfo = 0;
  vakt = xvakt;
  hdis = xhdis;
  getpsinfo();
  paint();
}


int getpnummer(int psin)
{
  char cd[100];

  if (psi[psin] == NULL) {
    return -1;
  }
  if (pstree == 0) {
    int pos, i;

    if ((pos = strpos(titel, "PID", 0)) < (int) 0) {
      cd[0] = 0;
    } else {
      for (i = pos; isdigit(psi[psin][i]); i--) {
      }
      for (  ; !(isdigit(psi[psin][i])); i++) {
      }
      pos = i;
      for (  ; isdigit(psi[psin][i]); i++) {
	cd[i - pos] = psi[psin][i];
      }
      cd[i - pos] = 0;
    }
  } else {
    int i;
    int r;

    cd[0] = 0;
    for (i = 0; ((psi[psin][i] != ',') && (psi[psin][i] != 0) && (psi[psin][i] != ')')); i++) {
    }
    if ((psi[psin][i] == 0) || (psi[psin][i] == ')')) {
      return -1;
    }
    i++;
    r = 0;
    for (  ; isdigit(psi[psin][i]); i++) {
      cd[r++] = psi[psin][i];
    }
    cd[r] = 0;
  }
  return atoi(cd);
}


sendsignal(int psin, int sig)
{
  int err = 0;


  if ((err = kill(getpnummer(psin), sig)) != 0) {
    endwin();
    perror("kill()");
    getch();
  }
  getpsinfo();
  paint();
}


suchen(int from)
{
  int vpos;
  int hpos;
  char s[BUFSIZE];

  for (vpos = from; psi[vpos] != NULL; vpos++) {
    Gross(s, psi[vpos]);
    hpos = strpos(s, suchstr, 0);
    if (hpos > (int) -1) {
      vakt = vpos;
      hdis = hpos;
      return;
    }
  }
}

main(argc, argv)
  int argc;
  char *argv[];
{
  int i;

  psparam = (char *) getenv("BPS_PSP");

  if (argc > 1) {
    char parmok = 0;

    if ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'T')) {
      pstree = 1;
      parmok = 1;
    }

    if ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) {
      printf("%s\n\n", blacky_ver_info);
      //      printkinfo(stdout);
      parmok = 1;
      exit(0);
    }

    if ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'C')) {
      psparam = argv[2];
      parmok = 1;
    }
    
    reloadtime = atoi(argv[argc - 1]);
    if (reloadtime != 0) {
      parmok = 1;
    }

    //      if ((argv[1][0] == '-') && ((toupper(argv[1][1]) == 'H') || (argv[1][1] == '?')))
    if (parmok == 0) {
      //      allblackyintro(blacky_ver_info);
      fprintf(stderr, "Help:\n");
      fprintf(stderr, "  bps [ -? | -t | -v | -c <param>] [rel]\n");
      fprintf(stderr, "  -    : Normal (ps)\n");
      fprintf(stderr, "  -?   : Help\n");
      fprintf(stderr, "  -c   : Set PS-Parameter. (Default: -auxwww)\n");
      fprintf(stderr, "  -t   : Using PS-Tree\n");
      fprintf(stderr, "  -v   : Version, Licenze\n");
      fprintf(stderr, "  rel  : Time in seconds for Autoreload-Interval (Default: Disable)\n");
      return;
    }
  }

  //  allblackyintro(blacky_ver_info);

  getpsinfo();

  /* Editor? */
  EDITOR = (char *) getenv("EDITOR");
  if (EDITOR == NULL) {
    EDITOR = (char *) malloc(3);
    if (EDITOR == NULL) {
      perror("malloc()");
      exit(1);
    }
    strcpy(EDITOR, "vi");
  }

  /* x-Term-Titel */
  {
    char s[200];
    sprintf(s, "%s uid=%d", getenv("HOSTNAME"), /*getenv("UID")*/ geteuid());
    blacky_xterm_set_titel("Blacky's Process Status", s/*getenv("HOSTNAME")*/);
  }

  /*printf("ts %d\n", vsize);
    exit(0);*/

  /*for (i = 0; psi[i] != NULL; i++)
    {
    printf("%d --> %s\n", i, psi[i]);
    }
    exit(0);*/
  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  /*signal(SIGALRM, alarmf);*/      /* 14  /  Alarm      - wenn gesetzte Zeit abgelaufen ist */

  /* Autoreload */
  signal(SIGALRM, reload);
  alarm(reloadtime);

  /* Fenstergre gendert? */
  signal(SIGWINCH, fg);         /* 28  /  ?          - grennderund des xTerms         */


  init_cur_graph();
  // kein Cursor
  curs_set(0);

  zeilen = LINES;
  zeichen = COLS;

  do
     {
       /*       gotoxy(14, 23);    */
       paint();
       switch (getch())
         {
	   /* EXIT */
	 case 'X':
	 case 'x':
	 case 'Q':
	 case 'q':
	   finish(0);
	   break;

	   /* DN */
	 case 258:
	 case '-':
	   vakt++;
	   break;

	   /* UP */
	 case 259:
	 case '+':
	   vakt--;
	   break;

	   /* <- */
	 case 260:
	 case '<':
	   hdis -= 5;
	   break;

	   /* -> */
	 case 261:
	 case '>':
	   hdis += 5;
	   break;

	   /* PG-UP */
	 case 339:
	   vakt -= (zeilen - 8) /* 16 */;
	   vdis -= (zeilen - 8) /* 16 */;
	   break;

	   /* PG-DN */
	 case 338:
	   vakt += (zeilen - 8) /* 16 */;
	   vdis += (zeilen - 8) /* 16 */;
	   break;

	   /* hangup */
	 case 'A':
	   sendsignal(vakt, 1);
	   break;

	   /* Quit */
	 case 'B':
	   sendsignal(vakt, 3);
	   break;

	   /* Terminate */
	 case 'C':
	   sendsignal(vakt, 15);
	   break;

	   /* Stop */
	 case 'D':
	   sendsignal(vakt, 19);
	   break;

	   /* Continue */
	 case 'E':
	   sendsignal(vakt, 18);
	   break;

	   /* ** KILL ** */
	 case 'F':
	   sendsignal(vakt, 9);
	   break;

	   /* reNICE */
	 case 'N':
	   {
	     char cd[50], cd2[50];

	     /*	     nouhr = 1;*/
	     alarm(0);
	     endwin();
	     fprintf(stderr, "new nice? (+20 [nidrig] bis -20 [hoch]): ");
	     scanf("%s", cd2);
	     sprintf(cd, "renice %s %d", cd2, getpnummer(vakt));
	     if (system(cd) != 0)
	       {
		 fprintf(stderr, "FEHLER AUFGETRETEN!\n");
		 /*		 getchar();		 */
		 getch();
	       }
	     getpsinfo();
	     alarm(reloadtime);
	     /*	     nouhr = 0;*/
	   }
	   break;
	   
	   /* ReScan */
	 case 'r':
	 case 'R':
	   alarm(0);
	   getpsinfo();
	   alarm(reloadtime);
	     break;

	     /* Suchen */
	 case '/':
	 case 's':
	 case 'S':
	   {
	     char s[200];

	     /*	     nouhr = 1;*/
	     alarm(0);
	     endwin();
	     fprintf(stderr, "Search for: ");
	     scanf("%s", s);
	     suchstr = (char *) malloc(strlen(s) + 1);
	     if (suchstr == NULL)
	       {
		 perror("");
		 exit(1);
	       }
	     /*	     strcpy(suchstr, s);*/
	     Gross(suchstr, s);
	     /*	     nouhr = 0;*/
	     suchen(0);
	     alarm(reloadtime);
	   }
	   break;

	   /* to HOME */
	 case 262:
	   vakt = 0;
	   hdis = 0;
	   break;

	   /* to END */
	 case 360:
	   vakt = vsize;
	   hdis = 0;
	   break;

	   /* W-Suchen */
	 case 'n':
	   if (suchstr == NULL)
	     {
	       break;
	     }
	   alarm(0);
	   suchen(vakt + 1);
	   alarm(reloadtime);
	   break;

	 case 'i':
	   {
	     char file[] = "/tmp/.Blacky__NO_WARRANTY_and_Pinfo";
	     char ss[100];
	     FILE *f;

	     alarm(0);
	     endwin();

	     if ((f = fopen(file, "w")) == NULL) {
	       break;
	     }
	     fprintf(f, "%s\n\n", blacky_ver_info);
	     //	     printkinfo(f);
	     ffsync(f);
	     fclose(f);

	     sprintf(ss, "%s %s", EDITOR, file);
	     system(ss);

	     paint();
	     alarm(reloadtime);
	   }
	   break;

	 case 'I':
	 case '=':
	   {
	     srcprocessinfo();
	     break;
	     
	     //	     char s[2000];

	     endwin();

	     //	     sprintf(s, "cd /proc/%d; file=%s; echo 'Process Info:' > $file; echo '************* cmdline *************' >> $file; cat cmdline | tr \"\\0\" \"\\n\"  >> $file; echo  >> $file; echo '*************   maps  *************' >> $file; cat maps >> $file; echo '*************   stat  *************' >> $file; cat stat >> $file; echo '*************  statm  *************' >> $file; cat statm >> $file; echo '************* status  *************' >> $file; cat status >> $file; echo '************* environ *************' >> $file; cat environ | tr \"\\0\" \"\\n\" >> $file; echo >> $file; echo '************* strings *************' >> $file; strings exe >> $file; %s $file; rm $file", getpnummer(vakt), "/tmp/.Blacky_blackyps.pi.ahcp", EDITOR);
	     //	     system(s);

	     paint();
	   }
	   break;

	   /* Set Autoscan */
	 case 'U':
	   {
	     char s[50];

	     alarm(0);
	     endwin();
	     fprintf(stderr, "Set timeintervall for AutoScan in seconds: (0 = Aus) ");
	     scanf("%s", s);
	     reloadtime = atoi(s);
	     alarm(reloadtime);
	   }
	   break;

	   /* PS-Tree */
	 case 't':
	   if (pstree == 0)
	     {
	       pstree = 1;
	       getpsinfo();
	     }
	   else
	     {
	       pstree = 0;
	       getpsinfo();
	     }
	   break;

	   // Redraw  - C-l
	 case ' ':
	 case 12:
	   endwin();
	   paint();
	   break;

	   // Vollbild
	 case 'h':
	 case 'H':
	 case 265:
	   if (vollbild) {
	     vollbild = 0;
	   } else {
	     vollbild = 1;
	   }
	   break;
    
	   /* Wenn keine bekannte Taste gedrckt wurde */
	 default:
	   break;
         } /* END CASE */     
   } while (1);

  /*
   GoToXY(50, 5);
   X := von Rechtz
   Y := von Links
  */

  /* move(o, l) :
      Bei NULL beginnend !!!
      o = von oben;
      l = von links; */
}


static void finish(int sig)
{
  /* Herrunterfahren */
  endwin();

  /* x-Term-Titel */
  blacky_xterm_set_titel("xterm", 0L);

  exit(0);
}


static void fg(int sig)
{
  signal(SIGWINCH, fg);

  endwin();
  refresh();
  zeilen = LINES;
  zeichen = COLS;
  endwin();
  paint();
  refresh();
}


static void reload(int sig) {
  signal(SIGALRM, reload);
  alarm(reloadtime);

  if (processinfo) {
    getprocessinfo(reload_getprocessinfo_pid);
  } else {
    getpsinfo();
  }
  paint();
  refresh();
}
